package com.idea.buildManage.model;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Data
public class ParkInfo implements Serializable {


    private String id;

    private String groupId;

    private String groupName;

    private String createdId;

    private Date createdAt;

    private Date updatedAt;

    private String nature;

    private String preSalesLicenseNumber;

    private String companyId;

    private Double buildArea;

    private Double landArea;

    private String projectApprovalDocument;

    private String engineeringPlanningPermit;

    private String constructionPermit;

    private String landCertificateNumber;

    private String landUsePermitNumber;

    private String volumeRatio;

    private String greenRatio;

    private BigDecimal price;

    private BigDecimal exceededPrice;

    private Integer areaStatus;

    private Integer saleStatus;

    private String regionalismCode;

    private String address;

    private String orderNum;

    private String archiveCode;

    private String introduction;

    private String organizationalCode;

    private String projectCode;

    private static final long serialVersionUID = 1L;


}