package com.idea.customerManagement.dto;

import com.idea.customerManagement.model.CustomerManagement;
import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

@Data
public class CustomerManagementDto extends CustomerManagement {

    private String buyerJson;

    private String groupDiscName;

    private String groupIds;

    private String discIds;

    /**
     * 放弃资格操作人
     */
    private String abandonmentName;

    private List<String> groupIdList;

    private List<String> discIdList;

    private String identityCard;

    private String statusStr;

    /**
     * 意向金收取状态
     */
    private int intentionalDepositStatus;

    /**
     * 是否已交认购金
     */
    private int roomSelectionCount;

    /**
     * 意向金余额
     */
    private BigDecimal intentionalDepositMoney;

    private String roomSelectionDateFrom;

    private String roomSelectionDateTo;

}
