package com.idea.customerManagement.excel;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.idea.customerManagement.model.Buyer;
import lombok.Data;

import java.util.List;

@Data
public class CustomerManagementExcel {

    @ExcelProperty(value = "小区名称")
    private String groupName;

    @ExcelProperty(value = "分期名称")
    private String discName;

    @ExcelProperty(value = "*选房日（年-月-日 时:分:秒)")
    private String roomSelectionDate;

    @ExcelProperty(value = "*批次号")
    private String batchNumber;

    @ExcelProperty(value = "*选房号")
    private String roomSelectionNumber;

    @ExcelProperty(value = "*购房1-姓名")
    private String buyerName;

    @ExcelProperty(value = "*购房1-身份证号")
    private String identityCard;

    @ExcelProperty(value = "*购房1-手机号")
    private String phone;

    @ExcelProperty(value = "关系")
    private String relationship;

    @ExcelProperty(value = "顺序号")
    private String orderNum;

    @ExcelProperty(value = "失败原因")
    private String reason;

    @ExcelIgnore
    private List<Buyer> buyers;

    @ExcelIgnore
    private String relationshipStr;

    @ExcelIgnore
    private Boolean duplicate;


}
