package com.idea.invoice.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ReceiptManageExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ReceiptManageExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdIsNull() {
            addCriterion("customer_management_id is null");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdIsNotNull() {
            addCriterion("customer_management_id is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdEqualTo(String value) {
            addCriterion("customer_management_id =", value, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdNotEqualTo(String value) {
            addCriterion("customer_management_id <>", value, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdGreaterThan(String value) {
            addCriterion("customer_management_id >", value, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdGreaterThanOrEqualTo(String value) {
            addCriterion("customer_management_id >=", value, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdLessThan(String value) {
            addCriterion("customer_management_id <", value, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdLessThanOrEqualTo(String value) {
            addCriterion("customer_management_id <=", value, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdLike(String value) {
            addCriterion("customer_management_id like", value, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdNotLike(String value) {
            addCriterion("customer_management_id not like", value, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdIn(List<String> values) {
            addCriterion("customer_management_id in", values, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdNotIn(List<String> values) {
            addCriterion("customer_management_id not in", values, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdBetween(String value1, String value2) {
            addCriterion("customer_management_id between", value1, value2, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andCustomerManagementIdNotBetween(String value1, String value2) {
            addCriterion("customer_management_id not between", value1, value2, "customerManagementId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdIsNull() {
            addCriterion("business_id is null");
            return (Criteria) this;
        }

        public Criteria andBusinessIdIsNotNull() {
            addCriterion("business_id is not null");
            return (Criteria) this;
        }

        public Criteria andBusinessIdEqualTo(String value) {
            addCriterion("business_id =", value, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdNotEqualTo(String value) {
            addCriterion("business_id <>", value, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdGreaterThan(String value) {
            addCriterion("business_id >", value, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdGreaterThanOrEqualTo(String value) {
            addCriterion("business_id >=", value, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdLessThan(String value) {
            addCriterion("business_id <", value, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdLessThanOrEqualTo(String value) {
            addCriterion("business_id <=", value, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdLike(String value) {
            addCriterion("business_id like", value, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdNotLike(String value) {
            addCriterion("business_id not like", value, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdIn(List<String> values) {
            addCriterion("business_id in", values, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdNotIn(List<String> values) {
            addCriterion("business_id not in", values, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdBetween(String value1, String value2) {
            addCriterion("business_id between", value1, value2, "businessId");
            return (Criteria) this;
        }

        public Criteria andBusinessIdNotBetween(String value1, String value2) {
            addCriterion("business_id not between", value1, value2, "businessId");
            return (Criteria) this;
        }

        public Criteria andBatchNumberIsNull() {
            addCriterion("batch_number is null");
            return (Criteria) this;
        }

        public Criteria andBatchNumberIsNotNull() {
            addCriterion("batch_number is not null");
            return (Criteria) this;
        }

        public Criteria andBatchNumberEqualTo(String value) {
            addCriterion("batch_number =", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberNotEqualTo(String value) {
            addCriterion("batch_number <>", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberGreaterThan(String value) {
            addCriterion("batch_number >", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberGreaterThanOrEqualTo(String value) {
            addCriterion("batch_number >=", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberLessThan(String value) {
            addCriterion("batch_number <", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberLessThanOrEqualTo(String value) {
            addCriterion("batch_number <=", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberLike(String value) {
            addCriterion("batch_number like", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberNotLike(String value) {
            addCriterion("batch_number not like", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberIn(List<String> values) {
            addCriterion("batch_number in", values, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberNotIn(List<String> values) {
            addCriterion("batch_number not in", values, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberBetween(String value1, String value2) {
            addCriterion("batch_number between", value1, value2, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberNotBetween(String value1, String value2) {
            addCriterion("batch_number not between", value1, value2, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberIsNull() {
            addCriterion("room_selection_number is null");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberIsNotNull() {
            addCriterion("room_selection_number is not null");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberEqualTo(String value) {
            addCriterion("room_selection_number =", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberNotEqualTo(String value) {
            addCriterion("room_selection_number <>", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberGreaterThan(String value) {
            addCriterion("room_selection_number >", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberGreaterThanOrEqualTo(String value) {
            addCriterion("room_selection_number >=", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberLessThan(String value) {
            addCriterion("room_selection_number <", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberLessThanOrEqualTo(String value) {
            addCriterion("room_selection_number <=", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberLike(String value) {
            addCriterion("room_selection_number like", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberNotLike(String value) {
            addCriterion("room_selection_number not like", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberIn(List<String> values) {
            addCriterion("room_selection_number in", values, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberNotIn(List<String> values) {
            addCriterion("room_selection_number not in", values, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberBetween(String value1, String value2) {
            addCriterion("room_selection_number between", value1, value2, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberNotBetween(String value1, String value2) {
            addCriterion("room_selection_number not between", value1, value2, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andHouseNameIsNull() {
            addCriterion("house_name is null");
            return (Criteria) this;
        }

        public Criteria andHouseNameIsNotNull() {
            addCriterion("house_name is not null");
            return (Criteria) this;
        }

        public Criteria andHouseNameEqualTo(String value) {
            addCriterion("house_name =", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameNotEqualTo(String value) {
            addCriterion("house_name <>", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameGreaterThan(String value) {
            addCriterion("house_name >", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameGreaterThanOrEqualTo(String value) {
            addCriterion("house_name >=", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameLessThan(String value) {
            addCriterion("house_name <", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameLessThanOrEqualTo(String value) {
            addCriterion("house_name <=", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameLike(String value) {
            addCriterion("house_name like", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameNotLike(String value) {
            addCriterion("house_name not like", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameIn(List<String> values) {
            addCriterion("house_name in", values, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameNotIn(List<String> values) {
            addCriterion("house_name not in", values, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameBetween(String value1, String value2) {
            addCriterion("house_name between", value1, value2, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameNotBetween(String value1, String value2) {
            addCriterion("house_name not between", value1, value2, "houseName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameIsNull() {
            addCriterion("buyer_name is null");
            return (Criteria) this;
        }

        public Criteria andBuyerNameIsNotNull() {
            addCriterion("buyer_name is not null");
            return (Criteria) this;
        }

        public Criteria andBuyerNameEqualTo(String value) {
            addCriterion("buyer_name =", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameNotEqualTo(String value) {
            addCriterion("buyer_name <>", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameGreaterThan(String value) {
            addCriterion("buyer_name >", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameGreaterThanOrEqualTo(String value) {
            addCriterion("buyer_name >=", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameLessThan(String value) {
            addCriterion("buyer_name <", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameLessThanOrEqualTo(String value) {
            addCriterion("buyer_name <=", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameLike(String value) {
            addCriterion("buyer_name like", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameNotLike(String value) {
            addCriterion("buyer_name not like", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameIn(List<String> values) {
            addCriterion("buyer_name in", values, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameNotIn(List<String> values) {
            addCriterion("buyer_name not in", values, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameBetween(String value1, String value2) {
            addCriterion("buyer_name between", value1, value2, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameNotBetween(String value1, String value2) {
            addCriterion("buyer_name not between", value1, value2, "buyerName");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeIsNull() {
            addCriterion("receipt_type is null");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeIsNotNull() {
            addCriterion("receipt_type is not null");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeEqualTo(String value) {
            addCriterion("receipt_type =", value, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeNotEqualTo(String value) {
            addCriterion("receipt_type <>", value, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeGreaterThan(String value) {
            addCriterion("receipt_type >", value, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeGreaterThanOrEqualTo(String value) {
            addCriterion("receipt_type >=", value, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeLessThan(String value) {
            addCriterion("receipt_type <", value, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeLessThanOrEqualTo(String value) {
            addCriterion("receipt_type <=", value, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeLike(String value) {
            addCriterion("receipt_type like", value, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeNotLike(String value) {
            addCriterion("receipt_type not like", value, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeIn(List<String> values) {
            addCriterion("receipt_type in", values, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeNotIn(List<String> values) {
            addCriterion("receipt_type not in", values, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeBetween(String value1, String value2) {
            addCriterion("receipt_type between", value1, value2, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptTypeNotBetween(String value1, String value2) {
            addCriterion("receipt_type not between", value1, value2, "receiptType");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyIsNull() {
            addCriterion("receipt_money is null");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyIsNotNull() {
            addCriterion("receipt_money is not null");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyEqualTo(BigDecimal value) {
            addCriterion("receipt_money =", value, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyNotEqualTo(BigDecimal value) {
            addCriterion("receipt_money <>", value, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyGreaterThan(BigDecimal value) {
            addCriterion("receipt_money >", value, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("receipt_money >=", value, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyLessThan(BigDecimal value) {
            addCriterion("receipt_money <", value, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyLessThanOrEqualTo(BigDecimal value) {
            addCriterion("receipt_money <=", value, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyIn(List<BigDecimal> values) {
            addCriterion("receipt_money in", values, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyNotIn(List<BigDecimal> values) {
            addCriterion("receipt_money not in", values, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("receipt_money between", value1, value2, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptMoneyNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("receipt_money not between", value1, value2, "receiptMoney");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberIsNull() {
            addCriterion("receipt_number is null");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberIsNotNull() {
            addCriterion("receipt_number is not null");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberEqualTo(String value) {
            addCriterion("receipt_number =", value, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberNotEqualTo(String value) {
            addCriterion("receipt_number <>", value, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberGreaterThan(String value) {
            addCriterion("receipt_number >", value, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberGreaterThanOrEqualTo(String value) {
            addCriterion("receipt_number >=", value, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberLessThan(String value) {
            addCriterion("receipt_number <", value, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberLessThanOrEqualTo(String value) {
            addCriterion("receipt_number <=", value, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberLike(String value) {
            addCriterion("receipt_number like", value, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberNotLike(String value) {
            addCriterion("receipt_number not like", value, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberIn(List<String> values) {
            addCriterion("receipt_number in", values, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberNotIn(List<String> values) {
            addCriterion("receipt_number not in", values, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberBetween(String value1, String value2) {
            addCriterion("receipt_number between", value1, value2, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptNumberNotBetween(String value1, String value2) {
            addCriterion("receipt_number not between", value1, value2, "receiptNumber");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusIsNull() {
            addCriterion("receipt_status is null");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusIsNotNull() {
            addCriterion("receipt_status is not null");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusEqualTo(Integer value) {
            addCriterion("receipt_status =", value, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusNotEqualTo(Integer value) {
            addCriterion("receipt_status <>", value, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusGreaterThan(Integer value) {
            addCriterion("receipt_status >", value, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("receipt_status >=", value, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusLessThan(Integer value) {
            addCriterion("receipt_status <", value, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusLessThanOrEqualTo(Integer value) {
            addCriterion("receipt_status <=", value, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusIn(List<Integer> values) {
            addCriterion("receipt_status in", values, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusNotIn(List<Integer> values) {
            addCriterion("receipt_status not in", values, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusBetween(Integer value1, Integer value2) {
            addCriterion("receipt_status between", value1, value2, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andReceiptStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("receipt_status not between", value1, value2, "receiptStatus");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberIsNull() {
            addCriterion("association_number is null");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberIsNotNull() {
            addCriterion("association_number is not null");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberEqualTo(String value) {
            addCriterion("association_number =", value, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberNotEqualTo(String value) {
            addCriterion("association_number <>", value, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberGreaterThan(String value) {
            addCriterion("association_number >", value, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberGreaterThanOrEqualTo(String value) {
            addCriterion("association_number >=", value, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberLessThan(String value) {
            addCriterion("association_number <", value, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberLessThanOrEqualTo(String value) {
            addCriterion("association_number <=", value, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberLike(String value) {
            addCriterion("association_number like", value, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberNotLike(String value) {
            addCriterion("association_number not like", value, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberIn(List<String> values) {
            addCriterion("association_number in", values, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberNotIn(List<String> values) {
            addCriterion("association_number not in", values, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberBetween(String value1, String value2) {
            addCriterion("association_number between", value1, value2, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andAssociationNumberNotBetween(String value1, String value2) {
            addCriterion("association_number not between", value1, value2, "associationNumber");
            return (Criteria) this;
        }

        public Criteria andCreatedIdIsNull() {
            addCriterion("created_id is null");
            return (Criteria) this;
        }

        public Criteria andCreatedIdIsNotNull() {
            addCriterion("created_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedIdEqualTo(String value) {
            addCriterion("created_id =", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdNotEqualTo(String value) {
            addCriterion("created_id <>", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdGreaterThan(String value) {
            addCriterion("created_id >", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdGreaterThanOrEqualTo(String value) {
            addCriterion("created_id >=", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdLessThan(String value) {
            addCriterion("created_id <", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdLessThanOrEqualTo(String value) {
            addCriterion("created_id <=", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdLike(String value) {
            addCriterion("created_id like", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdNotLike(String value) {
            addCriterion("created_id not like", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdIn(List<String> values) {
            addCriterion("created_id in", values, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdNotIn(List<String> values) {
            addCriterion("created_id not in", values, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdBetween(String value1, String value2) {
            addCriterion("created_id between", value1, value2, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdNotBetween(String value1, String value2) {
            addCriterion("created_id not between", value1, value2, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNull() {
            addCriterion("updated_at is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNotNull() {
            addCriterion("updated_at is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtEqualTo(Date value) {
            addCriterion("updated_at =", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotEqualTo(Date value) {
            addCriterion("updated_at <>", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThan(Date value) {
            addCriterion("updated_at >", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_at >=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThan(Date value) {
            addCriterion("updated_at <", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThanOrEqualTo(Date value) {
            addCriterion("updated_at <=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIn(List<Date> values) {
            addCriterion("updated_at in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotIn(List<Date> values) {
            addCriterion("updated_at not in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtBetween(Date value1, Date value2) {
            addCriterion("updated_at between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotBetween(Date value1, Date value2) {
            addCriterion("updated_at not between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdIsNull() {
            addCriterion("updated_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdIsNotNull() {
            addCriterion("updated_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdEqualTo(String value) {
            addCriterion("updated_id =", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdNotEqualTo(String value) {
            addCriterion("updated_id <>", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdGreaterThan(String value) {
            addCriterion("updated_id >", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdGreaterThanOrEqualTo(String value) {
            addCriterion("updated_id >=", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdLessThan(String value) {
            addCriterion("updated_id <", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdLessThanOrEqualTo(String value) {
            addCriterion("updated_id <=", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdLike(String value) {
            addCriterion("updated_id like", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdNotLike(String value) {
            addCriterion("updated_id not like", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdIn(List<String> values) {
            addCriterion("updated_id in", values, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdNotIn(List<String> values) {
            addCriterion("updated_id not in", values, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdBetween(String value1, String value2) {
            addCriterion("updated_id between", value1, value2, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdNotBetween(String value1, String value2) {
            addCriterion("updated_id not between", value1, value2, "updatedId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}