package com.idea.message.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
public class SysMessageInfo implements Serializable {
    private String id;

    private String title;

    private String versionNo;

    private String pushBy;

    private String pushName;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date pushTime;

    private String updateBy;

    private String updateName;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date updateTime;

    private String createBy;

    private String createName;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date createTime;

    private String state;

    private String annex;

    private String pushState;

    private String content;
}