package com.idea.transactionRecordManage.mapper;

import com.idea.customerManagement.dto.IntentionalDepositDto;
import com.idea.paymentManagement.dto.RefundManageDto;
import com.idea.paymentManagement.model.PayLog;
import com.idea.transactionRecordManage.vo.NccRecordVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TransactionRecordMapper {

    List<NccRecordVo> collectionRecord(NccRecordVo model);

    List<NccRecordVo> reFundRecord(NccRecordVo model);


    List<RefundManageDto> refundListByIds(NccRecordVo model);

    List<NccRecordVo> convertRecord(NccRecordVo model);


    List<IntentionalDepositDto> convertListByDate(@Param("startDate") String startDate,
                                                 @Param("endDate") String endDate);

}