package com.idea.workPanel.enume;

public enum WorkTrendsTypeEnum {

    RZ("入驻", "1"),
    TZ("退租", "2"),
    QT("清退", "3");

    public String name;
    public String value;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    WorkTrendsTypeEnum(String name, String value) {
        this.name = name;
        this.value = value;
    }

    public static WorkTrendsTypeEnum getNameByValue(String value) {
        for (WorkTrendsTypeEnum pse : WorkTrendsTypeEnum.values()) {
            if(value.equals(pse.getValue())){
                return pse;
            }
        }
        return null;
    }

}
